﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace WcfService1 {
	// NOTE: You can use the "Rename" command on the "Refactor" menu to change the interface name "IService1" in both code and config file together.
	[ServiceContract]
	public interface IService1 {
		[OperationContract]
		string GetData(int value);

		[OperationContract]
		CompositeType GetDataUsingDataContract(CompositeType composite);

		// TODO: Add your service operations here
		[OperationContract]
		Employee GetEmployeeInfo();

		[OperationContract]
		ResultMessage UploadFile(FileMessageName fmn);
	}

	// Use a data contract as illustrated in the sample below to add composite types to service operations.
	[DataContract]
	public class CompositeType {
		bool boolValue = true;
		string stringValue = "Hello ";

		[DataMember]
		public bool BoolValue {
			get { return boolValue; }
			set { boolValue = value; }
		}

		[DataMember]
		public string StringValue {
			get { return stringValue; }
			set { stringValue = value; }
		}
	}

	[DataContract]
	[KnownType("KnowType")]
	public class Employee {
		[DataMember]
		public string Name { get; set; }

		[DataMember]
		public int Age { get; set; }

		[DataMember]
		public AddInfo Address { get; set; }

		[DataMember]
		public object Scores { get; set; }

		static Type[] KnowType() {
			return new Type[] { typeof(Dictionary<string, int>) };
		}
	}

	[DataContract]
	public class AddInfo {
		[DataMember]
		public string City { get; set; }

		[DataMember]
		public String DetailAddress { get; set; }
	}

	[MessageContract]
	public class FileMessageName {
		[MessageHeader]
		public string FileName;

		[MessageBodyMember]
		public Stream FileStream;
	}

	[MessageContract]
	public class ResultMessage {
		[MessageHeader]
		public string ErrorMessage;

		[MessageBodyMember]
		public bool isSuccessed;
	}
}
